from time import sleep
from mindwave.parser import Parser
from numpy import array, average, nan
from  urllib import urlopen
FILENAME = 'data.tsv'
HOST = 'http://localhost'
PORT = '8080'

def run():
    p = Parser()
    p.write_serial("\xc2")

    record_baseline = False
    current_values = dict()
    current_values['attention'] = []
    current_values['meditation'] = []
    fluctuation = dict()
    fluctuation['attention'] = []
    fluctuation['attention'].append(20.0)
    fluctuation['meditation'] = []
    fluctuation['meditation'].append(20.0)
    i = 1
    while True:
        p.update()
        if p.sending_data:
            if p.current_attention and p.current_meditation:
                current_values['attention'].append(p.current_attention)
                current_values['meditation'].append(p.current_meditation)
        else:
            print 'not receiving data...'
            p.write_serial("\xc2")
            sleep(2)
        if p.current_attention == nan or p.current_meditation == nan:
            print 'nan values...!'
            p.write_serial("\xc2")
            sleep(2)

        i += 1
        avg_att = average(current_values['attention'])
        avg_med = average(current_values['meditation'])

        if i % 500 == 0:
            i = 0

            fluctuation['attention'].append(round(avg_att, 2))
            fluctuation['meditation'].append(round(avg_med, 2))

            print 'ATT:', avg_att, '|', fluctuation['attention'][-11:-1]
            print 'MED:', avg_med, '|', fluctuation['meditation'][-11:-1]
            att_vs_med = list(array(fluctuation['attention']) / array(fluctuation['meditation']))
            print att_vs_med[-1]
            print

            s1 = str(fluctuation['attention'][-21:])
            s2 = str(fluctuation['meditation'][-21:])
            s = '%s\t%s' % (s1, s2)
            out = open(FILENAME, 'w')
            out.write(s + '\n')
            out.close()

            URL = "%s:%s/brain/1/set?attention=%s&meditation=%s" % (HOST, PORT, s1, s2)
            print URL
            urlopen(URL)

            current_values['attention'] = []
            current_values['meditation'] = []

if __name__ == "__main__":
    run()
