import re
from formencode import validators, Invalid

class CommaSeparatedList(validators.FancyValidator):
    separator_re = re.compile(r',\s*')
    
    messages = {
        'empty': 'invalid value (empty)',
    }
    
    def _to_python(self, value, state):
        if value is None:
            return None
        value = value.strip()
        if not value:
            raise Invalid(self.message('empty', state), value, state)
        return self.separator_re.split(value)
