from os import path
from pyechonest import config
config.ECHO_NEST_API_KEY="XXTRQQPSNLAZ4UGII"
from pyechonest import song
from spotimeta import search_track
from Levenshtein import ratio

HOME = '/home/ocelma/source/musichackday/sf-2012/rest/util/echonest'
CACHE = '/cache/'

try:
    from hashlib import md5
except ImportError:
    from md5 import md5

def get_md5(text):
    """Returns the md5 hash of a string."""
    try:
        hash = md5()
        hash.update(text.encode('utf8'))
        return hash.hexdigest()
    except:
        return ''

def _get_relaxed_songs(artist):
    return song.search(artist=artist, max_tempo=80, max_energy=.6, sort='tempo-asc') 

def _get_danceable_songs(artist):
    return song.search(artist=artist, min_danceability=.8, sort='tempo-desc')

def _get_happy_songs(artist):
    return song.search(artist=artist, min_tempo=120, min_energy=0.8, sort='loudness-desc')

def _get_sad_songs(artist):
    return song.search(artist=artist, max_tempo=80, max_energy=.5, mode='0', sort='loudness-asc')

def get_songs(artist, type=None, cache=True):
    artist = artist.lower()
    name = get_md5(artist + type)
    filename = HOME + CACHE + name
    #print filename

    if name and path.exists(filename):
        return open(filename).read()
    else:
        print 'Cache filename not found!'
        if not type:
            results =  song.search(artist=artist)
        elif type=='relaxed':
            results =  _get_relaxed_songs(artist)
        elif type=='danceable':
            results =  _get_danceable_songs(artist)
        elif type=='happy':
            results =  _get_happy_songs(artist)
        elif type=='sad':
            results =  _get_sad_songs(artist)
        else:
            print 'type param incorrect!'
        tracks = [(track.artist_name.lower(), track.title.lower()) for track in results]
        spoti_tracks = []
        DISTANCE = 0.8
        for _artist, title in tracks:
            if ratio(artist.encode('utf8'), _artist.encode('utf8')) < DISTANCE:
                print artist, _artist
                continue
            try:
                uri = search_track('%s %s'%(artist, title))['result'][0]['href']
            except Exception, e:
                #print 'error spotimeta', e
                continue
            spoti_tracks.append((artist, title, uri, type))
        spoti_tracks = list(set(spoti_tracks))
        fp = open(filename, 'w')
        fp.write(str(spoti_tracks))
        return spoti_tracks

if __name__=="__main__":
    import sys
    artist = sys.argv[1]
    TYPES = ['relaxed', 'danceable', 'happy', 'sad']
    for type in TYPES:
        print get_songs(artist, type)
