import lucene, threading, sys
import reader
import searcher
import indexer

def init():
    lucene.initVM(lucene.CLASSPATH, maxheap = '2048M', vmargs='-Xrs')

def attach_thread():
    """attach the current thread to pylucene's JVM"""
    t = threading.currentThread()
    lucene.getVMEnv().attachCurrentThread(t.getName(), t.isDaemon())

def detach_thread():
    """detach the current thread from pylucene's JVM"""
    lucene.getVMEnv().detachCurrentThread()


def get_duplicate_keys(path, key):
    unique_d = dict()
    to_remove = dict()
    s = searcher.Search(path)
    wrong = 0
    for d in s.iterread():
        #print d.keys()
        try:
            val = d[key]
        except Exception,e:
            #print e
            wrong += 1
            print '\rWrong %d'%wrong,
            sys.stdout.flush()
            continue
        if unique_d.has_key(val[0]):
            unique_d[val[0]] = unique_d[val[0]] + 1
        else:
            unique_d[val[0]] = 1
    s.close()
    for k,v in unique_d.iteritems():
        if v > 1:
            to_remove[k] = v
    return to_remove

def delete_duplicates(index_path, key):
    to_remove = get_duplicate_keys(index_path, key)
    reader = lucene.IndexReader.open(index_path)
    i = 0
    print '\r%d removed'%i,
    sys.stdout.flush()
    for i in range(reader.maxDoc()):
        if reader.isDeleted(i):
           continue
        d = reader.document(i)
        val = d.get(key)
        if to_remove.has_key(val) and to_remove[val] > 1:
            to_remove[val] = to_remove[val] - 1
            reader.deleteDocument(i)
            print '\r%d removed'%i,
            sys.stdout.flush()
            i+=1
        else:
            print 'Not removing %s...'%val
    reader.close()
    indexer.indexer.optimize(index_path)
def merge_indexes(ouput_dir, input_dir_list):
    idx = indexer.indexer(ouput_dir)
    idx.open_index(True)
    idx.merge_indexes(input_dir_list)
    idx.close_index()
    
