import lucene

class basic_analyzer(lucene.PythonAnalyzer):
    def tokenStream(self, fieldName, reader):
        result = lucene.StandardTokenizer(reader)
        result = lucene.StandardFilter(result)
        result = lucene.LowerCaseFilter(result)
        result = lucene.ISOLatin1AccentFilter(result)
        return result    

class stop_latin_analyzer(lucene.PythonAnalyzer):
    def tokenStream(self, fieldName, reader):
        ENGLISH_STOP_WORDS = [
    "a", "an", "and", "are", "as", "at", "be", "but", "by",
    "for", "i", "if", "in", "into", "is",
    "no", "not", "of", "on", "or", "s", "such",
    "t", "that", "their", "then", "there", "these",
    "they", "this", "to", "was", "will", "with"
        ]
        CATALAN_STOP_WORDS = ['un','una','el','la','ell','ella','de','a','i','o','es','sa','els','les']

        result = lucene.StandardTokenizer(reader)
        result = lucene.StandardFilter(result)
        result = lucene.LowerCaseFilter(result)
        result = lucene.ISOLatin1AccentFilter(result)
        result = lucene.StopFilter(result, ENGLISH_STOP_WORDS + CATALAN_STOP_WORDS)
        #result = pylucene.EdgeNGramTokenizer(result, pylucene.EdgeNGramTokenizer.Side.FRONT,1 20)
        #print result
        return result
