# coding=utf8
import unicodedata

def unaccent(s):
    """remove accents from the given string
    
        >>> unaccent(u'\\xe1\\xe9\\xed\\xf3\\xfa') # áéíóú
        u'aeiou'
        >>> unaccent(u'\\xe0\\xe8\\xec\\xf2\\xf9') # àèìòù
        u'aeiou'
        >>> unaccent(u'\\xe4\\xeb\\xef\\xf6\\xfc') # âêîôû
        u'aeiou'
        >>> unaccent(u'\\xe2\\xea\\xee\\xf4\\xfb') # äëïöü
        u'aeiou'
        >>> unaccent(u'\\xf1') # ñ
        u'n'
    
    """
    if isinstance(s, str):
        s = unicode(s)
    return ''.join((c for c in unicodedata.normalize('NFD', s) if unicodedata.category(c) != 'Mn'))
